--- csdr.c.orig	2017-05-11 08:29:06 UTC
+++ csdr.c
@@ -43,6 +43,7 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH D
 #include <unistd.h>
 #include <time.h>
 #include <stdarg.h>
+#include <unistd.h>
 #include "libcsdr.h"
 #include "libcsdr_gpl.h"
 #include "ima_adpcm.h"
@@ -52,6 +53,12 @@ SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH D
 #include <errno.h>
 #include "fastddc.h"
 
+#ifdef __FreeBSD__
+#define CLOCK_MONOTONIC_SYSTEM	CLOCK_MONOTONIC
+#else
+#define CLCOK_MONOTONIC_SYSTEM	CLOCK_MONOTONIC_RAW
+#endif
+
 char usage[]=
 "csdr - a simple commandline tool for Software Defined Radio receiver DSP.\n\n"
 "usage: \n\n"
@@ -343,8 +350,8 @@ int main(int argc, char *argv[])
 	if(argc<=1) return badsyntax(0);
 	if(!strcmp(argv[1],"--help")) return badsyntax(0);
 
-	fcntl(STDIN_FILENO, F_SETPIPE_SZ, 65536*32);
-	fcntl(STDOUT_FILENO, F_SETPIPE_SZ, 65536*32);
+//	fcntl(STDIN_FILENO, F_SETPIPE_SZ, 65536*32);
+//	fcntl(STDOUT_FILENO, F_SETPIPE_SZ, 65536*32);
 	//fprintf(stderr, "csdr: F_SETPIPE_SZ\n");
 
 	if(!strcmp(argv[1],"setbuf"))
@@ -1767,15 +1774,15 @@ int main(int argc, char *argv[])
 		//initialize FFT library, and measure time
 		fprintf(stderr,"fft_benchmark: initializing... ");
 		struct timespec start_time, end_time;
-		clock_gettime(CLOCK_MONOTONIC_RAW, &start_time);
+		clock_gettime(CLOCK_MONOTONIC_SYSTEM, &start_time);
 		FFT_PLAN_T* plan=make_fft_c2c(fft_size,input,output,1,benchmark);
-		clock_gettime(CLOCK_MONOTONIC_RAW, &end_time);
+		clock_gettime(CLOCK_MONOTONIC_SYSTEM, &end_time);
 		fprintf(stderr,"done in %g seconds.\n",TIME_TAKEN(start_time,end_time));
 
 		//do the actual measurement about the FFT
-		clock_gettime(CLOCK_MONOTONIC_RAW, &start_time);
+		clock_gettime(CLOCK_MONOTONIC_SYSTEM, &start_time);
 		for(int i=0;i<fft_cycles;i++) fft_execute(plan);
-		clock_gettime(CLOCK_MONOTONIC_RAW, &end_time);
+		clock_gettime(CLOCK_MONOTONIC_SYSTEM, &end_time);
 		float time_taken_fft = TIME_TAKEN(start_time,end_time);
 		fprintf(stderr,"fft_benchmark: %d transforms of %d processed in %g seconds, %g seconds each.\n",fft_cycles,fft_size,time_taken_fft,time_taken_fft/fft_cycles);
 		return 0;
@@ -1978,11 +1985,11 @@ int main(int argc, char *argv[])
 			if(flowcontrol_is_buffering)
 			{
 				fprintf(stderr, "flowcontrol: buffering, flowcontrol_bufindex = %d\n", flowcontrol_bufindex);
-				if(flowcontrol_bufindex==flowcontrol_bufsize) { flowcontrol_is_buffering = 0; clock_gettime(CLOCK_MONOTONIC_RAW, &start_time); }
+				if(flowcontrol_bufindex==flowcontrol_bufsize) { flowcontrol_is_buffering = 0; clock_gettime(CLOCK_MONOTONIC_SYSTEM, &start_time); }
 				else if(read_return<=0) continue;
 			}
 			else {
-				clock_gettime(CLOCK_MONOTONIC_RAW, &end_time);
+				clock_gettime(CLOCK_MONOTONIC_SYSTEM, &end_time);
 				int thrust_added=0;
 				while( (all_bytes_written+thrust*flowcontrol_readsize) / TIME_TAKEN(start_time,end_time) < data_rate )
 				{
@@ -1991,7 +1998,7 @@ int main(int argc, char *argv[])
 				//if(!(test++%10)) fprintf(stderr, "abw=%g\n", all_bytes_written / TIME_TAKEN(start_time,end_time));
 				/*if(!thrust_added && TIME_TAKEN(start_time,end_time)>50)
 				{
-					clock_gettime(CLOCK_MONOTONIC_RAW, &start_time);
+					clock_gettime(CLOCK_MONOTONIC_SYSTEM, &start_time);
 					all_bytes_written=0;
 				}*/
 				while(all_bytes_written>data_rate && TIME_TAKEN(start_time,end_time)>1)
@@ -2037,11 +2044,11 @@ int main(int argc, char *argv[])
 			if(!time_now_sec)
 			{
 				time_now_sec=1;
-				clock_gettime(CLOCK_MONOTONIC_RAW, &start_time);
+				clock_gettime(CLOCK_MONOTONIC_SYSTEM, &start_time);
 			}
 			else
 			{
-				clock_gettime(CLOCK_MONOTONIC_RAW, &end_time);
+				clock_gettime(CLOCK_MONOTONIC_SYSTEM, &end_time);
 				float timetaken;
 				if(time_now_sec<(timetaken=TIME_TAKEN(start_time,end_time)))
 				{
